/************************************************
* FF.C - find first/find next demo				*
************************************************/

#include <stdio.h>		/* printf ...			*/
#include <dos.h>		/* FA_*					*/

/* ffblk definition - better than the one in	*/
/* dir.h, because it also defines the date and	*/
/* time structures.								*/
struct ffblk
	{
	char	rsvd[21];
	char	attrib;
	struct
		{
		unsigned second : 5;
		unsigned minute : 6;
		unsigned hour   : 5;
		} time;
	struct
		{
		unsigned day    : 5;
		unsigned month  : 4;
		unsigned year   : 7;
		} date;
	long	size;
	char	name[13];
	};

/* prototypes for findfirst & findnext */
int findfirst(char *, struct ffblk *, int);
int findnext(struct ffblk *);

long numBytes=0;		/* Number of file items	*/
int  numFiles=0;		/* Number of bytes		*/

/* printDir - print all files in directory that	*/
/* match the specification in 'name'			*/
void printDir(char *name)
	{
	struct ffblk t;
	int done;

	done = findfirst(name,&t,FA_RDONLY|FA_HIDDEN|
			FA_SYSTEM|FA_LABEL|FA_DIREC|FA_ARCH);
	while (!done)
		{
		printf("%-13.13s %8ld   %2d/%02d/%4d   "
			   "%2d:%02d:%02d   %c%c%c%c%c%c\n",
			   t.name,t.size,
			   t.date.month,t.date.day,
			   t.date.year+1980,
			   t.time.hour,t.time.minute,
			   t.time.second*2,
			   (t.attrib&FA_ARCH)  ? 'A' : '-',
			   (t.attrib&FA_DIREC) ? 'D' : '-',
			   (t.attrib&FA_HIDDEN)? 'H' : '-',
			   (t.attrib&FA_LABEL) ? 'L' : '-',
			   (t.attrib&FA_RDONLY)? 'R' : '-',
			   (t.attrib&FA_SYSTEM)? 'S' : '-');
		++numFiles;
		numBytes += t.size;
		done = findnext(&t);
		}
	}

void main(int argc, char *argv[])
	{
	int i;

	printf("ff - a directory utility\n");

	/* If no specific files listed, list all */
	if (argc < 2)
		printDir("*.*");
	else
		/* Otherwise, list all specified */
		for (i=1; i<argc; i++)
			printDir(argv[i]);
	printf("Total of %2d files\n     "
		   "%6ld bytes\n",numFiles,numBytes);
	}
