/************************************************
* STARBNCE.C - Demo of 2D vector transforms		*
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <graphics.h>
#include <conio.h>
#include <ctype.h>
#include <dos.h>
#define TRUE   (1==1)
#define FALSE  (1==0)
#define ISIN(a,b,c) (((c)>=(a))&&((c)<=(b)))
#define PI	(3.141592654)

typedef struct { float x,y; } CART;
typedef struct { float r,a; } POLAR;
typedef struct { int   x,y; } PHYS;

static int mC, mX, mY;

CART PolarToCart(POLAR *in)
	{
	CART retval;
	retval.x=cos(in->a)*in->r;
	retval.y=sin(in->a)*in->r;
	return retval;
	}

PHYS CartToPhys(CART *in)
	{
	PHYS retval;
	retval.x = (int)((in->x+1)*mX/2);
	retval.y = (int)((in->y+1)*mY/2);
	return retval;
	}

struct object
	{
	CART	pos;
	POLAR	polar[10];
	} star;

void drawStar(int c)
	{
	int i;
	CART c1;
	PHYS p1, p2;
	setcolor(c);
	for (i=0; i<5; i++)
		{
		c1 = PolarToCart(&star.polar[i+1]);
		c1.x = c1.x + star.pos.x;
		c1.y = c1.y + star.pos.y;
		p1 = CartToPhys(&c1);
		c1 = PolarToCart(&star.polar[i]);
		c1.x = c1.x + star.pos.x;
		c1.y = c1.y + star.pos.y;
		p2 = CartToPhys(&c1);
		line(p1.x,p1.y,p2.x,p2.y);
		}
	}

void main(void)
	{
	float	da, dr, dx, dy;
	int		c, i, done, grDriver, grErr, grMode;

	/* Initialize graphics system */
	detectgraph(&grDriver, &grMode);
	if (grDriver < 0)
		{
		fputs("No graphics hardware!\7",stderr);
		exit(1);
		}
	initgraph(&grDriver, &grMode,"e:\\tc\\v201");
	if (grErr=graphresult())
		{
		fprintf(stderr,"Graph error %d\n",grErr);
		exit(1);
		}
	mX = getmaxx(); mY=getmaxy(); mC=getmaxcolor();

	/* Create a star */
	star.pos.x=star.pos.y=0.0;
	for (i=0; i<6; i++)
		{
		star.polar[i].r = 0.6;
		star.polar[i].a = 4*PI/5 * i;
		}
	da = dr = dx = dy = 0.0;

	/* Do the demonstration */
	for (done=FALSE ; !done ; )
		{	/* If a key was pressed, process it */
		if (kbhit())
			{
			c=getch();
			switch (toupper(c))
				{
				case '\033': done=TRUE; 	break;
				case 'U':	 dy -= 0.025;	break;
				case 'D':	 dy += 0.025;	break;
				case 'L':	 dx -= 0.025;	break;
				case 'R':	 dx += 0.025;	break;
				case 'F':	 da += 0.05;	break;
				case 'B':	 da -= 0.05;	break;
				case '+':	 dr += 0.005;	break;
				case '-':	 dr -= 0.005;	break;
				}
			}

		/* Perform any rotations & scaling */
		for (i=0; i<6; i++)
			{
			star.polar[i].r+=dr;
			star.polar[i].a+=da;
			}
		dr=0;

		/* Perform any translation */
		if (fabs(star.pos.x+=dx) > 1.0)
			{ dx= -dx; star.pos.x += dx; }
		if (fabs(star.pos.y+=dy) > 1.0)
			{ dy= -dy; star.pos.y += dy; }

		/* Draw the star */
		drawStar(mC);
		delay(100);
		drawStar(0);
		}
	closegraph();
	}
